
using Infragistics.Windows.Automation.Peers.DataPresenter;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Automation.Peers;
using System.Windows.Automation.Provider;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SortOrder
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        XamDataGrid xamDataGrid1;
        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<Data> data = new ObservableCollection<Data>();

            #region data


            data.Add(new Data()
            {
                ID = 6,
                Category = "Cars",
                Capacity = 10
            });

          

            data.Add(new Data()
            {
                ID = 4,
                Category = "Planes",
                Capacity = 100
            });


            data.Add(new Data()
            {
                ID = 5,
                Category = "Games",
                Capacity = 50,
            });


            data.Add(new Data()
            {
                ID = 3,
                Category = "Sports",
                Capacity = 65
            });


            data.Add(new Data()
            {
                ID = 1,
                Category = "Games",
                Capacity = 100,
            });

            data.Add(new Data()
            {
                ID = 2,
                Category = "Cars",
                Capacity = 150
            });

            #endregion // data 

            xdg.DataContext = data;
        }
    }


    public class MyComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            Dictionary<int, string> sortingPriority = new Dictionary<int, string>();
            sortingPriority.Add(0, "Cars");
            sortingPriority.Add(1, "Planes");
            sortingPriority.Add(2, "Sports");
            sortingPriority.Add(3, "Games");

            var categoryItemsX =  sortingPriority.Where(xx => xx.Value.ToString() == x.ToString()).ToList();
            var categoryItemsY = sortingPriority.Where(yy => yy.Value.ToString() == y.ToString()).ToList();

            if (categoryItemsX[0].Key.Equals(categoryItemsY[0].Key))
                return 0;

            if (categoryItemsX[0].Key > categoryItemsY[0].Key)
                return 1;

            if (categoryItemsX[0].Key < categoryItemsY[0].Key)
                return -1;

            return -1;
        }
    }

    public class Data : INotifyPropertyChanged
    {
        private int id;
        private string category;
        private int capacity;

       
        

        public int Capacity
        {
            get { return capacity; }
            set
            {
                capacity = value;
                PropChanged("Capacity");
            }
        }

        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                PropChanged("ID");
            }
        }

        public string Category
        {
            get { return category; }
            set
            {
                this.category = value;
                PropChanged("Category");
            }
        }
        

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }


}
